<?php

// Given a file containing a dungeon configuration, parse it and
// output a JavaScript 2D array declaration.
function convertArray($filename)
{
    $fp = fopen($filename, "r");
    fscanf($fp, "%d %d ", $width, $height);
    
    // First read into a PHP 2D array
    for ($y = 0; $y < $height; $y++)
    {
        $line = trim(fgets($fp, 4096));
        
        $codes = explode(" ", $line);
        for ($x = 0; $x < count($codes); $x++)
            $grid[$x][$y] = $codes[$x];
    }
    fclose($fp);   
    
    // Output a JavaScript format 2D array where the first
    // dimension is the x-index and the second is the y-index.
    echo '[';
    for ($x = 0; $x < $width; $x++)
    {
        if ($x > 0)
            echo ',';                     
        echo '[';       
        for ($y = 0; $y < $height; $y++)
        {
            if ($y > 0)
                echo ',';
            echo '"' . $grid[$x][$y] . '"';
        }
        echo ']';
    }    
    echo ']';
}

?>

<!doctype html>
<html>
    <head>
        <title>Dungeon</title>
        <meta charset="utf-8">

        <script>
            // Load a 2D array with the data from the specified dungeon text file
            var tiles  = <?php convertArray($_GET["dungeon"]); ?>;
        </script>    
    </head>
    <body>
    </body>
</html>
